/*
	maravilha de codigo de id3 v1 e 2
	2/6/2005 8:26PM
*/
#ifndef INCLUDEUCHAR
#ifndef uchar
#define uchar unsigned char
#define uint unsigned int
#define ulong unsigned long
#define ushort  unsigned short
#endif
#endif
#include <windows.h>
#include <stdio.h>

#undef NDEBUG
#include <assert.h>

#include "pointer.h"

#pragma warning( disable : 4101 )

#pragma warning( disable : 4102 )
#pragma warning( disable : 4018 )

static int id3v2tag_check (char *filename);
__int64 _ftelli64_arab(FILE *stream);
int _fseeki64_arab(FILE *stream,__int64 offset,int origin);
__int64 id3v2tag (char *filename);

int rewrite_header (FILE * out, unsigned int written);

int write_prelim_header (FILE * out, int channels, int samplerate);

int detect (char *filename, __int64 *seekpoint);
extern int v1Track;
extern char v1Title[100];
extern char v1Artist[100];
extern char v1Album[100];
extern char v1Year[100];
extern int v1Genre;
extern char v1Comment[100];



extern int v2Composersize;
extern char *v2Composer;
extern int v2OriginalArtistsize;
extern char *v2OriginalArtist;
extern int v2Copyrightsize;
extern char *v2Copyright;
extern int v2URLsize;
extern char *v2URL;
extern int v2EncodedBysize;
extern char *v2EncodedBy;
extern int v2Commentsize;
extern char *v2Comment;
extern int v2Genresize;
extern char *v2Genre;
extern int v2Yearsize;
extern char *v2Year;
extern int v2Albumsize;
extern char *v2Album;
extern int v2Artistsize;
extern char *v2Artist;
extern int v2Titlesize;
extern char *v2Title;
extern int v2Tracksize;
extern char *v2Track;


extern char tempfolder[];


void rfree (void *add);
void *rmalloc (int size);


int remove_id3v2_tag (char *filename);


int id3v2tag_ok_write (char *filename);

int id3v2tag_ok (char *filename);


short invertbits16 (short value);

int invertbits32 (int value);


extern const char *const ID3v1_genre[];

int remove_id3v1_tag (char *filename);


int id3v1tag_ok_write (char *filename);

int id3v1tag_ok (char *filename);


int v2cleanupforcado ();
void dprintf (char *format, ...);
int save_to_file (char *infile, char *data, int size, int mode, int limit);
double getvalf (double maxa, double porr);
double getporf (double maxa, double fatiaa);
int id3tag (char *filename, int mode, float *iglobalfloat, int *ianalized,
	    int convertmode);
int id3tagcheck (char *filename);
int mygain (uchar * buf, uint len, float factor);
char *getnetstatus (int *value);
int set_sendmessage_nwnd (int value);
extern void _VDBG_dump (void);
extern uint getval (int max, uint por);
extern uint getpor (int max, uint fatia);
extern int decode_file (char *infile, char *outfile);
int debug_rede (char *url);
int set_port (int port);
int set_passive (int pasv);
int resume_winsock ();
int pause_winsock ();
int cancel_winsock ();
int set_user (char *url);
int set_pass (char *url);
int id3tag (char *filename, int mode, float *iglobalfloat, int *ianalized,
	    int convertmode);
int set_dest_path (char *path);
int detect (char *filename, __int64 *seekpoint);
int __stdcall startapi (int parameter);

void dprintf (char *format, ...);
void mprintf (char *format, ...);

unsigned int buffer_fread (void *buffer, unsigned int size,
			   unsigned int count, FILE * stream);
size_t fread_unbuffered(void *ptr, size_t size, size_t nelem, FILE *stream);
size_t fwrite_unbuffered(const void *ptr, size_t size, size_t nelem, FILE *stream);
int finalizeplayer ();

int enablefilebuffersmart ();

int minbuffersize (int size);


extern int __cdecl invertbits32 (int value);
extern short __cdecl invertbits16 (short value);
extern int __cdecl createtempfilename (char *path1, char *destfile);
extern int __cdecl detect_readonly_file (char *filename);
extern __int64 __cdecl fix_filesize (char *filename, __int64 len);
extern void __cdecl replace_char_binary (char *temp, char init, char out,
					 int len);
extern int __cdecl rsp_get_error (char *buffer);
extern void __cdecl rsp_error_print ();
extern int __cdecl checkoverflow_minuschar2 (char a, char b, char *result);
extern int __cdecl checkoverflow_minuschar (char a, char b, char *result);
extern int __cdecl checkoverflow_pluschar (char a, char b, char *result);
extern void __cdecl dprintf (char *format, ...);
extern int __cdecl fix8 (int value);
extern int __cdecl fix4 (int value);
extern int __cdecl fix2 (int value);
extern int __cdecl rspparser (char *instring, char *delimiter,
			      char *returnstring, int comand);
extern void __cdecl stripfilenameandpath_url (char *path, char *onlypath,
					      char *onlyfilename);
extern int __cdecl stripfilenameandpath (char *path, char *onlypath,
					 char *onlyfilename);
extern int __cdecl octaltoint (char *p);
extern char *__cdecl inttooctal (unsigned int value, int numberofitens);
static int __cdecl getbits (unsigned int value, unsigned int bit);
extern int __cdecl setbits (unsigned int value, unsigned int bit,
			    unsigned int bitvalue);
extern int __cdecl newsetbits (unsigned int value, unsigned int bit,
			       unsigned int bitvalue);
extern unsigned int __cdecl binarioparadecimal (char *binval);
extern char *__cdecl decimalparabinarioprintf (unsigned int value);
extern char *__cdecl decimalparabinario (unsigned int value);
extern char *__cdecl decimalparabinarioold (unsigned int value);
extern char __cdecl pegaultimocaracter (char *path);
extern double __cdecl inittimer2 (int value);
extern float __cdecl inittimer (unsigned int comando);
extern int __cdecl rspgetdrivetype (char *path1);
extern char *__cdecl rspgetcomputername ();
extern int __cdecl rspsetcurrentdirectory (char *path);
extern char *__cdecl rspgetcurrentdirectory ();
extern char *__cdecl rspgetsystemdirectory ();
extern char *__cdecl rspgetwindowsdirectory ();
extern char *__cdecl rspgettemppath ();
extern int __cdecl save_to_file (char *infile, char *data, int size, int mode,
				 int limit);
extern __int64 __cdecl getfilesize (char *infile);
extern unsigned int __cdecl getval (int max, unsigned int por);
extern double __cdecl getvalf (double maxa, double porr);
extern unsigned int __cdecl getmax (int por, unsigned int fatia);
extern unsigned int __cdecl getpor (int max, unsigned int fatia);
extern double __cdecl getporf (double maxa, double fatiaa);
extern int __cdecl contastringinsensitive (char *comando, char *string);
extern int __cdecl contastringsensitive (char *comando, char *string);
extern int __cdecl pegaposicaoinsensitivefinal (char *comando, char *string);
extern int __cdecl pegaposicaosensitivefinal (char *comando, char *string);
extern int __cdecl pegaposicaoinsensitive (char *comando, char *string);
extern int __cdecl pegaposicaosensitive (char *comando, char *string);
extern int __cdecl pegaposicaosensitive_new (char *comando, char *string);
extern int __cdecl pegaposicaosensitivefinal_new (char *comando,
						  char *string);
extern int __cdecl procuradordestringsensitive (char *comando, char *string);
extern int __cdecl procuradordestringinsensitive (char *comando,
						  char *string);
extern int __cdecl checkmaxsize (char *comando);
extern void __cdecl stripchar (char *intcomando, char caracter);
extern void __cdecl stripspace (char *intcomando);
extern void __cdecl trocadordebackslashtras (char *path);
extern void __cdecl trocadordebackslashfrente (char *path);
extern void __cdecl adicionadordebackslashtras (char *path);
extern void __cdecl adicionadordebackslashfrente (char *path);
extern void __cdecl removedordeespaconofinal (char *path);
extern void __cdecl removedordecaracternofinal (char *path, char caracter);
extern void __cdecl removedordecaracternoinicio (char *path, char caracter);
extern void __cdecl removedordeespaconoinicio (char *path);
extern void __cdecl changecharacter (char *path, char itemtosearch,
				     char finalcharacter);
extern int __cdecl countitens (char *comand, char item);
extern void __cdecl strtolower (char *path);
extern void __cdecl strtoupper (char *path);
extern int __cdecl testdirectory (char *path);
extern int __cdecl createtestfilename (char *path1);
extern int __cdecl pathexists (char *path);
extern int __cdecl pathappearsvalid (char *path);
extern int __cdecl ispathreadonly (char *path);
extern int __cdecl ispathfolder (char *path);
extern int __cdecl ispathfile (char *path);
extern void __cdecl geterrorstringrspmakedir (int errorcode, char *path);
extern int __cdecl rspmakedirUNIX (char *destination, char *path);
extern int __cdecl rspmakedir (char *path);
extern char *__cdecl validanomedearquivoerrorstring ();
extern int __cdecl validanomedearquivo (char *path);
extern char *__cdecl validatefoldertocreateerrorstring ();
extern int __cdecl validatefoldertocreate (char *path);
extern int __cdecl rspposicaofixa (int mode, int value);
extern int __cdecl wildcardselection (const char *path, const char *string1);
extern void __cdecl sgenrand (unsigned long seed);
extern int __cdecl genrand ();


extern void __cdecl init_iir ();
extern int __cdecl iir (char *d, int length, int channels);

extern void __cdecl init_iir2 ();
extern int __cdecl iir2 (char *d, int length, int channels);

int convertmp3towav (char *filename, char *outname);

int configequalizer (int b60, int b170, int b310, int b600, int b1000,
		     int b3000, int b6000, int b12000, int b14000,
		     int b16000);

int setvolume (int newvalue);


int v2cleanup ();

int configequalizer2 (int b60, int b170, int b310, int b600, int b1000,
		      int b3000, int b6000, int b12000, int b14000,
		      int b16000);


int isclosed ();


WCHAR* __stdcall utf8towide (const char *pUTF8);


int reinitplayer ();

FILE *buffer_fopen (const char *filename, const char *mode);

long buffer_ftell (FILE * stream);


int buffer_fseek (FILE * stream, long offset, int origin);


int buffer_fclose (FILE * stream);

int ispathfile (char *path);

int enablefilebuffer ();

int disablefilebuffer ();


void sgenrand (unsigned long seed);
int genrand ();


int ispathfolder (char *path);

int id3v2tag_ok (char *filename);

double inittimer2 (int value);



int createtempfilename (char *path1, char *destfile);

int save_to_file (char *infile, char *data, int size, int mode, int limit);

char tempfolder[300];


int naloc = 0;

#ifdef _debug_v2_ok_

#define dprintf printf
int
setdebuginformation (char *string)
{


	return 0;

}
#endif

/*HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH*/


void *
rmalloc (int size)
{

	naloc++;

//dprintf       ("malloc naloc %d \n", naloc);

	return (malloc (size));

}

void
rfree (void *add)
{
	naloc--;

	//dprintf       ("free naloc %d \n", naloc);

	free (add);

}


/*HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH*/

#define malloc rmalloc
#define free rfree


__int64 fix_filesize (char *filename, __int64 len);

int detect_readonly_file (char *filename);


int v2Composersize = 0;
char *v2Composer = NULL;
int v2OriginalArtistsize = 0;
char *v2OriginalArtist = NULL;
int v2Copyrightsize = 0;
char *v2Copyright = NULL;
int v2URLsize = 0;
char *v2URL = NULL;
int v2EncodedBysize = 0;
char *v2EncodedBy = NULL;
int v2Commentsize = 0;
char *v2Comment = NULL;
int v2Genresize = 0;
char *v2Genre = NULL;
int v2Yearsize = 0;
char *v2Year = NULL;
int v2Albumsize = 0;
char *v2Album = NULL;
int v2Artistsize = 0;
char *v2Artist = NULL;
int v2Titlesize = 0;
char *v2Title = NULL;
int v2Tracksize = 0;
char *v2Track = NULL;



int pegaposicaoinsensitive (char *comando, char *string);



int v1Track;
char v1Title[100];
char v1Artist[100];
char v1Album[100];
char v1Year[100];
int v1Genre;
char v1Comment[100];

const char *const ID3v1_genre[] = {
/*  1*/ "Blues",
/*  2*/ "Classic Rock",
/*  3*/ "Country",
/*  4*/ "Dance",
/*  5*/ "Disco",
/*  6*/ "Funk",
/*  7*/ "Grunge",
/*  8*/ "Hip-Hop",
/*  9*/ "Jazz",
/* 10*/ "Metal",
/* 11*/ "New Age",
/* 12*/ "Oldies",
/* 13*/ "Other",
/* 14*/ "Pop",
/* 15*/ "R&B",
/* 16*/ "Rap",
/* 17*/ "Reggae",
/* 18*/ "Rock",
/* 19*/ "Techno",
/* 20*/ "Industrial",
/* 21*/ "Alternative",
/* 22*/ "Ska",
/* 23*/ "Death Metal",
/* 24*/ "Pranks",
/* 25*/ "Soundtrack",
/* 26*/ "Euro-Techno",
/* 27*/ "Ambient",
/* 28*/ "Trip-Hop",
/* 29*/ "Vocal",
/* 30*/ "Jazz+Funk",
/* 31*/ "Fusion",
/* 32*/ "Trance",
/* 33*/ "Classical",
/* 34*/ "Instrumental",
/* 35*/ "Acid",
/* 36*/ "House",
/* 37*/ "Game",
/* 38*/ "Sound Clip",
/* 39*/ "Gospel",
/* 40*/ "Noise",
/* 41*/ "Alternative Rock",
/* 42*/ "Bass",
/* 43*/ "Soul",
/* 44*/ "Punk",
/* 45*/ "Space",
/* 46*/ "Meditative",
/* 47*/ "Instrumental Pop",
/* 48*/ "Instrumental Rock",
/* 49*/ "Ethnic",
/* 50*/ "Gothic",
/* 51*/ "Darkwave",
/* 52*/ "Techno-Industrial",
/* 53*/ "Electronic",
/* 54*/ "Pop-Folk",
/* 55*/ "Eurodance",
/* 56*/ "Dream",
/* 57*/ "Southern Rock",
/* 58*/ "Comedy",
/* 59*/ "Cult",
/* 60*/ "Gangsta",
/* 61*/ "Top 40",
/* 62*/ "Christian Rap",
/* 63*/ "Pop/Funk",
/* 64*/ "Jungle",
/* 65*/ "Native American",
/* 66*/ "Cabaret",
/* 67*/ "New Wave",
/* 68*/ "Psychadelic",
/* 69*/ "Rave",
/* 70*/ "Showtunes",
/* 71*/ "Trailer",
/* 72*/ "Lo-Fi",
/* 73*/ "Tribal",
/* 74*/ "Acid Punk",
/* 75*/ "Acid Jazz",
/* 76*/ "Polka",
/* 77*/ "Retro",
/* 78*/ "Musical",
/* 79*/ "Rock & Roll",
/* 80*/ "Hard Rock",
	/* 81 */ "Folk",
	/* Winamp extensions */
/* 82*/ "Folk/Rock",
/* 83*/ "National Folk",
/* 84*/ "Swing",
/* 85*/ "Fast-Fusion",
/* 86*/ "Bebob",
/* 87*/ "Latin",
/* 88*/ "Revival",
/* 89*/ "Celtic",
/* 90*/ "Bluegrass",
/* 91*/ "Avantgarde",
/* 92*/ "Gothic Rock",
/* 93*/ "Progressive Rock",
/* 94*/ "Psychedelic Rock",
/* 95*/ "Symphonic Rock",
/* 96*/ "Slow Rock",
/* 97*/ "Big Band",
/* 98*/ "Chorus",
/* 99*/ "Easy Listening",
/*100*/ "Acoustic",
/*101*/ "Humour",
/*102*/ "Speech",
/*103*/ "Chanson",
/*104*/ "Opera",
/*105*/ "Chamber Music",
/*106*/ "Sonata",
/*107*/ "Symphony",
/*108*/ "Booty Bass",
/*109*/ "Primus",
/*110*/ "Porn Groove",
/*111*/ "Satire",
	/*112 */ "Slow Jam",
	/* Winamp 1.7 */
/*113*/ "Club",
/*114*/ "Tango",
/*115*/ "Samba",
/*116*/ "Folklore",
	/*117 */ "Ballad",
	/* Winamp 1.90 */
/*118*/ "Power Ballad",
/*119*/ "Rhythmic Soul",
/*120*/ "Freestyle",
/*121*/ "Duet",
/*122*/ "Punk Rock",
/*123*/ "Drum Solo",
/*124*/ "A Capella",
/*125*/ "Euro-House",
/*126*/ "Dance Hall",
/*127*/ "Goa",
/*128*/ "Drum & Bass",
/*129*/ "Club-House",
/*130*/ "Hardcore",
/*131*/ "Terror",
/*132*/ "Indie",
/*133*/ "BritPop",
/*134*/ "Negerpunk",
/*135*/ "Polsk Punk",
/*136*/ "Beat",
/*137*/ "Christian Gangsta",
/*138*/ "Heavy Metal",
/*139*/ "Black Metal",
/*140*/ "Crossover",
/*141*/ "Contemporary Christian",
/*142*/ "Christian Rock",
	/*143 */ "Merengue",
	/* Winamp 1.91 */
/*144*/ "Salsa",
/*145*/ "Thrash Metal",
/*146*/ "Anime",
/*147*/ "JPop",
/*148*/ "Synthpop",
	" ",
};


static int
id3v2tag_check (char *filename)
{

	FILE *astdin = NULL;
	int ret;
	int returnvalue;
	static uchar item[255];
	uint fatia1;
	uint fatia2;
	uint fatia3;
	uint fatia4;


//   __asm
//   {
//      int 3;
//   }

	//disassemble (1);


	if ((astdin = _wfopen (utf8towide(filename), L"rb")) == NULL)
	  {

		  return 0;
	  }

	ret = fread_unbuffered ((char *) item, 1, 10, astdin);
	fclose (astdin);
	if (ret == 10)
	  {

		  if (('I' == item[0]) && (item[1] == 'D')
		      && (item[2] == '3'))
		    {

			    ;	//dprintf("tem id3 tag \n");

			    fatia1 = (uint) item[6];
			    fatia2 = (uint) item[7];
			    fatia3 = (uint) item[8];
			    fatia4 = (uint) item[9];
			    fatia1 = (fatia1 << (7 * 3)) | (fatia2 << (7 * 2))
				    | (fatia3 << (7)) | fatia4;


			    ;	//dprintf("valor do tag %d %x \n", fatia1, fatia1);
			    if (getfilesize (filename) < fatia1)
			      {

				      return 0;
			      }
			    return fatia1 + 10;
		    }

	  }

	return 0;
}




int
id3v1tag_ok (char *filename)
{

/*funcao fixa , nao muda mais*/



	char buf[200];

	FILE *stream = NULL;
	int returnvalue = 0;
	__int64 ret;

	;			//dprintf("filename %s \n", filename);

	if ((stream = _wfopen (utf8towide(filename), L"rb")) == NULL)	//"rb+"
	  {

		  returnvalue = 1;	// Cannot open mp3 file
		  goto saida;

	  }


	ret = getfilesize (filename);

	if (ret < 128)

	  {
		  returnvalue = 3;	// invalid file
		  goto saida;

	  }


	ret = _fseeki64_arab (stream, -128, SEEK_END);

	ret = fread_unbuffered (buf, 1, 128, stream);

	if (128 == ret)
	  {
		  ;		//dprintf("leu 128 \n");
		  if (memcmp (buf, "TAG", 3) == 0)
		    {


			    uchar *ptr;



			    memset (v1Title, 0, 100);
			    memset (v1Artist, 0, 100);
			    memset (v1Album, 0, 100);
			    memset (v1Year, 0, 100);
			    memset (v1Comment, 0, 100);

			    memcpy (v1Title, &buf[3], 30);
			    memcpy (v1Artist, &buf[3 + 30], 30);
			    memcpy (v1Album, &buf[3 + 30 + 30], 30);
			    memcpy (v1Year, &buf[3 + 30 + 30 + 30], 4);





			    ptr = &buf[125];

			    if (0 == *ptr)
			      {
				      memcpy (v1Comment,
					      &buf[3 + 30 + 30 + 30 + 4], 28);

				      ptr = &buf[126];

				      ;	//dprintf("valor lido de track %d \n", *ptr);
				      v1Track = *ptr;

			      }
			    else
			      {

				      memcpy (v1Comment,
					      &buf[3 + 30 + 30 + 30 + 4], 30);
				      v1Track = 0;

			      }

			    ptr = &buf[127];

			    ;
			    v1Genre = *ptr;


			    if (v1Genre > 148)
			      {
				      v1Genre = 148;
			      }

		    }
		  else
		    {

			    ;	//dprintf("nao tem id3tag \n");
			    returnvalue = 2;	// v1 not found
			    goto saida;

		    }

	  }
	else
	  {
		  ;		//dprintf("nao leu 128 \n");
		  returnvalue = 2;	// v1 not found
		  goto saida;

	  }


	;
      saida:
	;

	if (stream)
	  {

		  fclose (stream);

	  }

	;			//dprintf("valor de returnvalue %d \n", returnvalue);
	return returnvalue;

}


int
id3v1tag_ok_write (char *filename)
{

/*funcao fixa , nao muda mais*/

	char buf[200];//ha ha ha
	uchar eu = 0;

	FILE *stream = NULL;
	int returnvalue = 0;
	__int64 ret;

	;			//dprintf("filename %s \n", filename);


	if (detect_readonly_file (filename))
	  {

		  returnvalue = 4;
		  goto saida;

	  }

	if ((stream = _wfopen (utf8towide(filename), L"rb+")) == NULL)	//"rb+"
	  {

		  returnvalue = 1;	// Cannot open mp3 file
		  goto saida;

	  }


	ret = getfilesize (filename);

	if (ret < 128)

	  {
		  returnvalue = 3;	// invalid file
		  goto saida;

	  }


	ret = _fseeki64_arab (stream, -128, SEEK_END);

	ret = fread_unbuffered (buf, 1, 128, stream);

	if (128 == ret)
	  {



		  ;		//dprintf("leu 128 \n");
		  if (memcmp (buf, "TAG", 3) == 0)
		    {
			    ;	//dprintf("achou id3 tag \n");

			    ret = _fseeki64_arab (stream, -128, SEEK_END);

			    ret = fwrite_unbuffered ("TAG", 1, 3, stream);
			    ret = fwrite_unbuffered (v1Title, 1, 30, stream);
			    ret = fwrite_unbuffered (v1Artist, 1, 30, stream);
			    ret = fwrite_unbuffered (v1Album, 1, 30, stream);
			    ret = fwrite_unbuffered (v1Year, 1, 4, stream);


			    if (v1Track)
			      {
				      eu = 0;

				      ret = fwrite_unbuffered (v1Comment, 1, 28, stream);
				      ret = fwrite_unbuffered (&eu, 1, 1, stream);


				      eu = v1Track;

				      ret = fwrite_unbuffered (&eu, 1, 1, stream);

			      }
			    else
			      {

				      ret = fwrite_unbuffered (v1Comment, 1, 30, stream);
			      }

			    eu = v1Genre;


			    ret = fwrite_unbuffered (&eu, 1, 1, stream);


		    }
		  else
		    {

			    ;	//dprintf("nao achou id3 tag \n");

			    ret = _fseeki64_arab (stream, 0, SEEK_END);

			    ret = fwrite_unbuffered ("TAG", 1, 3, stream);
			    ret = fwrite_unbuffered (v1Title, 1, 30, stream);
			    ret = fwrite_unbuffered (v1Artist, 1, 30, stream);
			    ret = fwrite_unbuffered (v1Album, 1, 30, stream);
			    ret = fwrite_unbuffered (v1Year, 1, 4, stream);


			    if (v1Track)
			      {
				      eu = 0;

				      ret = fwrite_unbuffered (v1Comment, 1, 28, stream);
				      ret = fwrite_unbuffered (&eu, 1, 1, stream);

				      eu = v1Track;

				      ret = fwrite_unbuffered (&eu, 1, 1, stream);

			      }
			    else
			      {
				      ret = fwrite_unbuffered (v1Comment, 1, 30, stream);
			      }

			    eu = v1Genre;

			    ret = fwrite_unbuffered (&eu, 1, 1, stream);

		    }

	  }
	else
	  {
		  ;		//dprintf("nao leu 128 \n");
		  returnvalue = 2;	// v1 not found
		  goto saida;

	  }


	;
      saida:
	;

	if (stream)
	  {

		  fclose (stream);

	  }

	;			//dprintf("valor de returnvalue %d \n", returnvalue);
	return returnvalue;

}


int
remove_id3v1_tag (char *filename)
{

	__int64 ret;
	//disassemble (1);
	if (detect_readonly_file (filename))
	  {

		  return 3;


	  }

	ret = id3v1tag_ok (filename);



	if (0 == ret)
	  {








		  ret = fix_filesize (filename, getfilesize (filename) - 128);

		  if (0 == ret)
		    {

			    return 0;

		    }

	  }
	else
	  {

		  return 0;	//dont have id3v1 tag or invalid file

	  }

	return 1;		//unable to remove id3v1 tag


}

/*HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH*/

static void
fixframe (char *theframe, int size, int mode)
{

	char *temp;

	char *temp2;
	int i;
	int valid = 0;



	temp = malloc (size + 10);

	temp2 = theframe;

	if (0 == mode)
	  {

		  //dprintf("erro nao poderi acontecer \n");

	  }


	if (1 == mode)
	  {


		  if (size <= 1)
		    {
			    strcpy (theframe, "");
			    goto saifora;

		    }

		  temp2++;

		  strcpy (temp, temp2);

		  strcpy (theframe, temp);

		  goto saifora;

	  }

	if (2 == mode)
	  {
//modo wxxx
		  if (size <= 2)
		    {
			    strcpy (theframe, "");
			    goto saifora;

		    }

		  temp2++;


		  for (i = 0; i < (size - 2); i++)
		    {
			    //dprintf("modo 2 valor de temp2 %d \n", *temp2);
			    if (0 == *temp2)
			      {

				      //dprintf("locaizou 0 de dois \n");
				      temp2++;
				      goto jump2;
			      }
			    temp2++;
		    }

		  strcpy (theframe, "");
		  goto saifora;

		jump2:

		  strcpy (temp, temp2);

		  strcpy (theframe, temp);

		  goto saifora;

	  }


	if (5 == mode)
	  {
		  if (size <= 5)
		    {
			    strcpy (theframe, "");
			    goto saifora;

		    }

		  temp2++;
		  temp2++;
		  temp2++;
		  temp2++;


		  for (i = 0; i < (size - 5); i++)
		    {
			    //dprintf("valor de temp2 %d \n", *temp2);
			    if (0 == *temp2)
			      {
				      //dprintf("locaizou 0 de cinco \n");

				      temp2++;
				      goto jump5;
			      }
			    temp2++;
		    }

		  strcpy (theframe, "");
		  goto saifora;

		jump5:

		  strcpy (temp, temp2);

		  strcpy (theframe, temp);

		  goto saifora;

	  }


      saifora:

	free (temp);
}


/*
#define DWORDSWAP(dw) (((dw) >> 24) |\ (((dw) >> 8) & 0x0000FF00) |\ (((dw) << 8) & 0x00FF0000) |\ (((dw) << 24) & 0xFF000000))
*/
static int
invertbits2 (int value)
{


	return (int) ((((uint) value) >> 24) |
		      ((((uint) value) >> 8) & 0x0000FF00) |
		      ((((uint) value) << 8) & 0x00FF0000) |
		      ((((uint) value) << 24) & 0xFF000000));
}


static int
invertbits (int value)
{

	int out;
	char *input = (char *) &value;
	char *output = (char *) &out;
	output[0] = input[3];
	output[1] = input[2];
	output[2] = input[1];
	output[3] = input[0];
	return out;
}

/*HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH*/



static int
getv2data (char *filename, char *data, int size)
{

	int ret;
	FILE *stream = NULL;
	int returnvalue = 0;
	if ((stream = _wfopen (utf8towide(filename), L"rb")) == NULL)	//"rb+"
	  {
		  returnvalue = 1;
		  goto saida;	// Cannot open mp3 file
	  }

	//dprintf("vai ler do arquivo %d \n", size);
	ret = fread_unbuffered (data, 1, size, stream);
	if (ret == size)
	  {
		  returnvalue = 0;
		  goto saida;
	  }
	else
	  {
		  returnvalue = 2;
		  goto saida;
	  }


      saida:


	fclose (stream);
	return returnvalue;
}

/*HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH*/


int
id3v2tag_ok (char *filename)
{
	__int64 thesize = 0;

	int mode = 0;
	int framesize;
	int tamanhodetag = 0;
	int ret;
	int returnvalue = 0;
	char *itens = NULL;
	char *ptr;
	char v2nome[10];
	int *iptr;
	char *theframe = NULL;
	v2Composersize = 0;
	v2OriginalArtistsize = 0;
	v2Copyrightsize = 0;
	v2URLsize = 0;
	v2EncodedBysize = 0;
	v2Commentsize = 0;
	v2Genresize = 0;
	v2Yearsize = 0;
	v2Albumsize = 0;
	v2Artistsize = 0;
	v2Titlesize = 0;
	v2Tracksize = 0;

//   __asm
//   {
//
//      int 3;
//
//   }


//mprintf("estamos dentro\n");
	//disassemble (1);

	thesize = getfilesize (filename);


	if (v2Track)
	  {

		  free (v2Track);
		  v2Track = NULL;
	  }

	if (v2Title)
	  {

		  free (v2Title);
		  v2Title = NULL;
	  }

	if (v2Artist)
	  {

		  free (v2Artist);
		  v2Artist = NULL;
	  }

	if (v2Album)
	  {

		  free (v2Album);
		  v2Album = NULL;
	  }

	if (v2Year)
	  {

		  free (v2Year);
		  v2Year = NULL;
	  }

	if (v2Genre)
	  {

		  free (v2Genre);
		  v2Genre = NULL;
	  }

	if (v2Comment)
	  {

		  free (v2Comment);
		  v2Comment = NULL;
	  }

	if (v2EncodedBy)
	  {

		  free (v2EncodedBy);
		  v2EncodedBy = NULL;
	  }

	if (v2URL)
	  {

		  free (v2URL);
		  v2URL = NULL;
	  }

	if (v2Copyright)
	  {

		  free (v2Copyright);
		  v2Copyright = NULL;
	  }

	if (v2OriginalArtist)
	  {

		  free (v2OriginalArtist);
		  v2OriginalArtist = NULL;
	  }


	if (v2Composer)
	  {

		  free (v2Composer);
		  v2Composer = NULL;
	  }

	// dprintf("id3v2tag_check 1 \n");
	ret = id3v2tag_check (filename);
	//dprintf("id3v2tag_check 2 \n");




	if (ret)
	  {
// temo tag check


		  tamanhodetag = ret;;	//dprintf("temos v2 tag check %d \n", ret);
// somente copiamos os itens iniciais num arquivo

		  //dprintf("vai alocar %d \n", ret + 100);
		  itens = malloc (ret + 100);
		  //dprintf("getv2data 1 \n");
		  ret = getv2data (filename, itens, ret);
		  //dprintf("getv2data 2 \n");
		  if (ret)
		    {

			    returnvalue = 2;	// cannot load data from file
			    goto saida;
		    }



		  ptr = itens;
		  ptr = ptr + 10;

		getinfo:





		  if (0 == *ptr || ((ptr - itens) + 10) >= tamanhodetag)
		    {

			    goto finish;
		    }


		  memset (v2nome, 0, 10);
		  memcpy (v2nome, ptr, 4);;	//dprintf("deve ser o nome .%s. \n", v2nome);
		  ptr = ptr + 4;;	//dprintf("%d %d %d %d  \n", ptr[0], ptr[1], ptr[2], ptr[3]);
		  iptr = (int *) ptr;;	//dprintf("Deve ser o tamanho %x \n", *iptr);
		  framesize = invertbits (*iptr);;	//dprintf("Deve ser o tamanho %d \n", framesize);
		  //dprintf(" valor de invertbits %d\n", framesize);


//mprintf("estamos dentro2\n");

		  if ((framesize >= (thesize) || (framesize < 0)))
		    {

			    framesize = 1;
			    memset (v2nome, 0, 10);

		    }

//mprintf("estamos dentro21\n");

		  ptr = ptr + 4;
		  ptr++;
		  ptr++;

		  if (framesize > 64000)
		    {
			    returnvalue = 1;	//nao tem id3v2
			    goto saida;
		    }

		  //mprintf("estamos dentro22 %d \n",framesize);
		  theframe = malloc (framesize + 10);
		  memset (theframe, 0, framesize + 10);
		  //mprintf("estamos dentro23\n");
		  memcpy (theframe, ptr, framesize);
		  //mprintf("estamos dentro24\n");
		  mode = 1;
		  if (!memcmp (v2nome, "WXXX", 4))
		    {
			    mode = 2;
		    }

		  if (!memcmp (v2nome, "COMM", 4))
		    {
			    mode = 5;
		    }
//mprintf("estamos dentro3\n");

		  //dprintf("usando mod %d string %s \n", mode, v2nome);
		  fixframe (theframe, framesize, mode);
		  if (!memcmp (v2nome, "TENC", 4))
		    {
//TENC  encoded by , flag 40 00
			    ;	//dprintf("achou encoder \n");
			    if (strlen (theframe) && framesize > 1)
			      {
				      v2EncodedBysize = strlen (theframe);
// limpando caso esteja sujo
				      if (v2EncodedBy)
					{
						;	//dprintf("relimpando malloc \n");
						free (v2EncodedBy);
						v2EncodedBy = NULL;
					}


				      if ((v2EncodedBysize + 100) > thesize)
					{

						returnvalue = 1;	//nao tem id3v2
						goto saida;
					}

				      v2EncodedBy =
					      malloc (v2EncodedBysize + 100);
				      memset (v2EncodedBy, 0,
					      v2EncodedBysize + 100);
				      strcpy (v2EncodedBy, theframe);
			      }

		    }

		  if (!memcmp (v2nome, "WXXX", 4))
		    {
//TENC  encoded by , flag 40 00
			    ;	//dprintf("achou WXXX url \n");
			    if (strlen (theframe) && framesize > 2)
			      {
				      v2URLsize = strlen (theframe);
// limpando caso esteja sujo
				      if (v2URL)
					{
						;	//dprintf("relimpando malloc \n");
						free (v2URL);
						v2URL = NULL;
					}

				      if ((v2URLsize + 100) > thesize)
					{

						returnvalue = 1;	//nao tem id3v2
						goto saida;
					}
				      v2URL = malloc (v2URLsize + 100);
				      memset (v2URL, 0, v2URLsize + 100);
				      strcpy (v2URL, theframe);
			      }

		    }


		  if (!memcmp (v2nome, "TCOP", 4))
		    {
//TENC  encoded by , flag 40 00
			    ;	//dprintf("achou TCOP copyright \n");
			    if (strlen (theframe) && framesize > 1)
			      {
				      v2Copyrightsize = strlen (theframe);
// limpando caso esteja sujo
				      if (v2Copyright)
					{
						;	//dprintf("relimpando malloc \n");
						free (v2Copyright);
						v2Copyright = NULL;
					}

				      if ((v2Copyrightsize + 100) > thesize)
					{

						returnvalue = 1;	//nao tem id3v2
						goto saida;
					}
				      v2Copyright =
					      malloc (v2Copyrightsize + 100);
				      memset (v2Copyright, 0,
					      v2Copyrightsize + 100);
				      strcpy (v2Copyright, theframe);
			      }

		    }

		  if (!memcmp (v2nome, "TOPE", 4))
		    {
//TENC  encoded by , flag 40 00
			    // dprintf("achou TOPE original artist \n");
			    if (strlen (theframe) && framesize > 1)
			      {
				      v2OriginalArtistsize =
					      strlen (theframe);
// limpando caso esteja sujo
				      if (v2OriginalArtist)
					{
						//  dprintf("relimpando malloc \n");
						free (v2OriginalArtist);
						v2OriginalArtist = NULL;
					}

				      if ((v2OriginalArtistsize + 100) >
					  thesize)
					{

						returnvalue = 1;	//nao tem id3v2
						goto saida;
					}
				      v2OriginalArtist =
					      malloc (v2OriginalArtistsize +
						      100);
				      memset (v2OriginalArtist, 0,
					      v2OriginalArtistsize + 100);
				      strcpy (v2OriginalArtist, theframe);
			      }

		    }

		  if (!memcmp (v2nome, "TCOM", 4))
		    {
//TENC  encoded by , flag 40 00
			    ;	//dprintf("achou TCOM composer \n");
			    if (strlen (theframe) && framesize > 1)
			      {
				      v2Composersize = strlen (theframe);
// limpando caso esteja sujo
				      if (v2Composer)
					{
						;	//dprintf("relimpando malloc \n");
						free (v2Composer);
						v2Composer = NULL;
					}

				      if ((v2Composersize + 100) > thesize)
					{

						returnvalue = 1;	//nao tem id3v2
						goto saida;
					}
				      v2Composer =
					      malloc (v2Composersize + 100);
				      memset (v2Composer, 0,
					      v2Composersize + 100);
				      strcpy (v2Composer, theframe);
			      }

		    }

		  if (!memcmp (v2nome, "TCON", 4))
		    {
//TENC  encoded by , flag 40 00
			    ;	//dprintf("achou TCON genre \n");
			    if (strlen (theframe) && framesize > 1)
			      {
				      v2Genresize = strlen (theframe);
// limpando caso esteja sujo
				      if (v2Genre)
					{
						;	//dprintf("relimpando malloc \n");
						free (v2Genre);
						v2Genre = NULL;
					}

				      if ((v2Genresize + 100) > thesize)
					{

						returnvalue = 1;	//nao tem id3v2
						goto saida;
					}
				      v2Genre = malloc (v2Genresize + 100);
				      memset (v2Genre, 0, v2Genresize + 100);
				      strcpy (v2Genre, theframe);
				      {


					      int ret;
					      int ret2;
					      ret = pegaposicaoinsensitive
						      (v2Genre, "(");
					      ret2 = pegaposicaoinsensitive
						      (v2Genre, ")");
					      if (ret && ret2)
						{

// ok achamos tag de winamp
							char *temp;
							temp = malloc (100);
							strcpy (temp, &v2Genre[ret]);;	//dprintf("veja oque pegou .%s. \n", temp);
							ret = atoi (temp);;	//dprintf("valor de ret %d \n", ret);
							if (ret < 148)
							  {

								  strcpy (v2Genre, ID3v1_genre[ret]);
								  v2Genresize
									  =
									  strlen
									  (v2Genre);
							  }


							free (temp);
						}

					      ;	//dprintf("valor de genre %s \n", v2Genre);
				      }


			      }

		    }

		  if (!memcmp (v2nome, "TRCK", 4))
		    {
//TENC  encoded by , flag 40 00
			    ;	//dprintf("achou TRCK track \n");
			    if (strlen (theframe) && framesize > 1)
			      {
				      v2Tracksize = strlen (theframe);
// limpando caso esteja sujo
				      if (v2Track)
					{
						;	//dprintf("relimpando malloc \n");
						free (v2Track);
						v2Track = NULL;
					}

				      if ((v2Tracksize + 100) > thesize)
					{

						returnvalue = 1;	//nao tem id3v2
						goto saida;
					}
				      v2Track = malloc (v2Tracksize + 100);
				      memset (v2Track, 0, v2Tracksize + 100);
				      strcpy (v2Track, theframe);
			      }

		    }

		  if (!memcmp (v2nome, "COMM", 4))
		    {
//TENC  encoded by , flag 40 00
			    ;	//dprintf("achou COMM comments \n");
			    if (strlen (theframe) && framesize > 5)
			      {
				      v2Commentsize = strlen (theframe);
// limpando caso esteja sujo
				      if (v2Comment)
					{
						;	//dprintf("relimpando malloc \n");
						free (v2Comment);
						v2Comment = NULL;
					}

				      if ((v2Commentsize + 100) > thesize)
					{

						returnvalue = 1;	//nao tem id3v2
						goto saida;
					}
				      v2Comment =
					      malloc (v2Commentsize + 100);
				      memset (v2Comment, 0,
					      v2Commentsize + 100);
				      strcpy (v2Comment, theframe);
			      }

		    }

		  if (!memcmp (v2nome, "TYER", 4))
		    {
//TENC  encoded by , flag 40 00
			    ;	//dprintf("achou TYER ano \n");
			    if (strlen (theframe) && framesize > 1)
			      {
				      v2Yearsize = strlen (theframe);
// limpando caso esteja sujo
				      if (v2Year)
					{
						;	//dprintf("relimpando malloc \n");
						free (v2Year);
						v2Year = NULL;
					}

				      if ((v2Yearsize + 100) > thesize)
					{

						returnvalue = 1;	//nao tem id3v2
						goto saida;
					}
				      v2Year = malloc (v2Yearsize + 100);
				      memset (v2Year, 0, v2Yearsize + 100);
				      strcpy (v2Year, theframe);
			      }

		    }
		  if (!memcmp (v2nome, "TALB", 4))
		    {
//TENC  encoded by , flag 40 00
			    ;	//dprintf("achou TALB album \n");
			    if (strlen (theframe) && framesize > 1)
			      {
				      v2Albumsize = strlen (theframe);
// limpando caso esteja sujo
				      if (v2Album)
					{
						;	//dprintf("relimpando malloc \n");
						free (v2Album);
						v2Album = NULL;
					}

				      if ((v2Albumsize + 100) > thesize)
					{

						returnvalue = 1;	//nao tem id3v2
						goto saida;
					}
				      v2Album = malloc (v2Albumsize + 100);
				      memset (v2Album, 0, v2Albumsize + 100);
				      strcpy (v2Album, theframe);
			      }

		    }

		  if (!memcmp (v2nome, "TPE1", 4))
		    {
//TENC  encoded by , flag 40 00
			    ;	//dprintf("achou TPE1 artist \n");
			    if (strlen (theframe) && framesize > 1)
			      {
				      v2Artistsize = strlen (theframe);
// limpando caso esteja sujo
				      if (v2Artist)
					{
						;	//dprintf("relimpando malloc \n");
						free (v2Artist);
						v2Artist = NULL;
					}

				      if ((v2Artistsize + 100) > thesize)
					{

						returnvalue = 1;	//nao tem id3v2
						goto saida;
					}
				      v2Artist = malloc (v2Artistsize + 100);
				      memset (v2Artist, 0,
					      v2Artistsize + 100);
				      strcpy (v2Artist, theframe);
			      }

		    }

		  if (!memcmp (v2nome, "TIT2", 4))
		    {
//TENC  encoded by , flag 40 00
			    //dprintf("achou TIT2 title \n");
			    if (strlen (theframe) && framesize > 1)
			      {
				      v2Titlesize = strlen (theframe);
// limpando caso esteja sujo
				      if (v2Title)
					{
						//dprintf("relimpando malloc \n");
						free (v2Title);
						v2Title = NULL;
					}

				      if ((v2Titlesize + 100) > thesize)
					{

						returnvalue = 1;	//nao tem id3v2
						goto saida;
					}
				      v2Title = malloc (v2Titlesize + 100);
				      memset (v2Title, 0, v2Titlesize + 100);
				      strcpy (v2Title, theframe);
				      //dprintf("string de title %s \n", theframe);
			      }

		    }


		  ptr += framesize;
		  free (theframe);
		  theframe = NULL;
		  goto getinfo;
		finish:


		  ;
	  }
	else
	  {

		  ;		//dprintf("nao tem v2 \n");
		  returnvalue = 1;	//nao tem id3v2
		  goto saida;
	  }




      saida:



	if (returnvalue)
	  {

		  //v2cleanupforcado ();

	  }

	if (itens)
	  {
		  ;		//dprintf("liberando itens \n");
		  free (itens);
	  }

	if (theframe)
	  {

		  ;		//dprintf("nao pode ocorrer \n");
		  free (theframe);
	  }

	return returnvalue;
}


int
id3v2tag_ok_write (char *filename)
{
	int noterror = 0;
	__int64 thesize = 0;
	FILE *in = NULL;
	FILE *out = NULL;
	int sizetowrite = 0;
	int didfilename = 0;
	int framesize;
	int tamanhodetag = 0;
	int ret;
	int ret2;
	int returnvalue = 0;
	char *itens = NULL;
	char *ptr;
	char v2nome[10];
	int *iptr;
	char *theframe = NULL;
	char *theframe2 = NULL;
	char mp3file[300];
	char header[11];
	int frame_handled = 0;
	int COMM = 1;
	int TALB = 1;
	int TCOM = 1;
	int TCON = 1;
	int TCOP = 1;
	int TENC = 1;
	int TIT2 = 1;
	int TOPE = 1;
	int TPE1 = 1;
	int TRCK = 1;
	int TYER = 1;
	int WXXX = 1;
	memset (mp3file, 0, 300);
	if (detect_readonly_file (filename))
	  {

		  returnvalue = 1;	//read only
		  goto saida;
	  }

	thesize = getfilesize (filename);

	ret = createtempfilename (tempfolder, mp3file);


	// dprintf("%s \n", mp3file);
	if (!ret)
	  {
		  didfilename = 1;;	//dprintf("conseguiu criar arquivo .%s. \n", mp3file);
	  }
	else
	  {

		  ;		//dprintf("nao criou arquivo \n");
		  returnvalue = 2;	//unable to create temp file
		  goto saida;
	  }


//ret =
//save_to_file (mp3file, "testando escrita\n", strlen("testando escrita\n"),  1, 0);
//


	header[0] = 'I';
	header[1] = 'D';
	header[2] = '3';
	// Version number
	header[3] = 3;
	header[4] = 0;
	// Clear Flags byte
	header[5] = 0;
	// Write tag length
	header[6] = 0;		//((dwTagSize >> 21) & 0x7F );
	header[7] = 0;		//((dwTagSize >> 14) & 0x7F );
	header[8] = 0;		//((dwTagSize >>  7) & 0x7F );
	header[9] = 0;		//((dwTagSize      ) & 0x7F );
	ret = save_to_file (mp3file, header, 10, 1, 0);
	// return 0;
	ret = id3v2tag_check (filename);




//ret2=id3v2tag_ok(filename);

/*
if(ret2)
{
ret=0;
}
*/

	if (ret)
	  {



		  tamanhodetag = ret;;	//dprintf("temos v2 tag check %d \n", ret);
		  itens = malloc (ret + 100);
		  ret = getv2data (filename, itens, ret);
		  if (ret)
		    {

			    returnvalue = 3;	// cannot load data from file
			    goto saida;
		    }


		  ;		//dprintf("oque pegou %s \n", itens);
		  ptr = itens;
		  ptr = ptr + 10;
		getinfo:


		  ;		//dprintf("item %s \n", ptr);
		  ;		//dprintf("valor de um e outro %d %d \n", (ptr - itens) + 10,
		  // tamanhodetag);
		  if (0 == *ptr || ((ptr - itens) + 10) >= tamanhodetag)
		    {
			    ;	//dprintf("chegou no fim \n");
// nao tem item valido , entao vamos embora
/*HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH*/
//finalizador do systema
			    if (TENC)
			      {

				      frame_handled = 1;
				      sizetowrite = 1;
				      if (v2EncodedBy)
					{
						sizetowrite =
							sizetowrite +
							strlen (v2EncodedBy);
					}

				      ret = save_to_file (mp3file, "TENC", 4,
							  1, 0);
				      ret = sizetowrite;
				      ret = invertbits (ret);
				      // dprintf("1 valor de invertbits %d\n", ret);
				      ret = save_to_file (mp3file,
							  (char *) &ret, 4, 1,
							  0);
				      header[0] = 0x40;
				      header[1] = 0;
				      save_to_file (mp3file, header, 2, 1, 0);
				      save_to_file (mp3file, "\0", 1, 1, 0);
				      if (v2EncodedBy)
					{
						save_to_file (mp3file,
							      v2EncodedBy,
							      strlen
							      (v2EncodedBy),
							      1, 0);
					}





			      }

//goto saida;


			    if (WXXX)
			      {

				      ;	//dprintf("achou WXXX url \n");
				      frame_handled = 1;
				      sizetowrite = 2;
				      if (v2URL)
					{
						sizetowrite =
							sizetowrite +
							strlen (v2URL);
					}

				      ret = save_to_file (mp3file, "WXXX", 4,
							  1, 0);
				      ret = sizetowrite;
				      ret = invertbits (ret);
				      //dprintf("1 valor de invertbits %d\n", ret);
				      ret = save_to_file (mp3file,
							  (char *) &ret, 4, 1,
							  0);
				      header[0] = 0;
				      header[1] = 0;
				      save_to_file (mp3file, header, 2, 1, 0);
				      save_to_file (mp3file, "\0\0", 2, 1, 0);
				      if (v2URL)
					{
						save_to_file (mp3file, v2URL,
							      strlen (v2URL),
							      1, 0);
					}




			      }


			    if (TCOP)
			      {
//TENC  encoded by , flag 40 00
				      ;	//dprintf("achou TCOP copyright \n");
				      frame_handled = 1;
				      sizetowrite = 1;
				      if (v2Copyright)
					{
						sizetowrite =
							sizetowrite +
							strlen (v2Copyright);
					}

				      ret = save_to_file (mp3file, "TCOP", 4,
							  1, 0);
				      ret = sizetowrite;
				      ret = invertbits (ret);
				      //dprintf("1 valor de invertbits %d\n", ret);
				      ret = save_to_file (mp3file,
							  (char *) &ret, 4, 1,
							  0);
				      header[0] = 0;
				      header[1] = 0;
				      save_to_file (mp3file, header, 2, 1, 0);
				      save_to_file (mp3file, "\0", 1, 1, 0);
				      if (v2Copyright)
					{
						save_to_file (mp3file,
							      v2Copyright,
							      strlen
							      (v2Copyright),
							      1, 0);
					}





			      }

			    if (TOPE)
			      {

				      ;	//dprintf("achou TOPE original artist \n");
				      frame_handled = 1;
				      sizetowrite = 1;
				      if (v2OriginalArtist)
					{
						sizetowrite =
							sizetowrite +
							strlen
							(v2OriginalArtist);
					}

				      ret = save_to_file (mp3file, "TOPE", 4,
							  1, 0);
				      ret = sizetowrite;
				      ret = invertbits (ret);
				      //dprintf("1 valor de invertbits %d\n", ret);
				      ret = save_to_file (mp3file,
							  (char *) &ret, 4, 1,
							  0);
				      header[0] = 0;
				      header[1] = 0;
				      save_to_file (mp3file, header, 2, 1, 0);
				      save_to_file (mp3file, "\0", 1, 1, 0);
				      if (v2OriginalArtist)
					{
						save_to_file (mp3file,
							      v2OriginalArtist,
							      strlen
							      (v2OriginalArtist),
							      1, 0);
					}




			      }

			    if (TCOM)
			      {

				      ;	//dprintf("achou TCOM composer \n");
				      frame_handled = 1;
				      sizetowrite = 1;
				      if (v2Composer)
					{
						sizetowrite =
							sizetowrite +
							strlen (v2Composer);
					}

				      ret = save_to_file (mp3file, "TCOM", 4,
							  1, 0);
				      ret = sizetowrite;
				      ret = invertbits (ret);
				      //dprintf("1 valor de invertbits %d\n", ret);
				      ret = save_to_file (mp3file,
							  (char *) &ret, 4, 1,
							  0);
				      header[0] = 0;
				      header[1] = 0;
				      save_to_file (mp3file, header, 2, 1, 0);
				      save_to_file (mp3file, "\0", 1, 1, 0);
				      if (v2Composer)
					{
						save_to_file (mp3file,
							      v2Composer,
							      strlen
							      (v2Composer), 1,
							      0);
					}



			      }

			    if (TCON)
			      {

				      ;	//dprintf("achou TCON genre \n");
				      frame_handled = 1;
				      sizetowrite = 1;
				      if (v2Genre)
					{
						sizetowrite =
							sizetowrite +
							strlen (v2Genre);
					}

				      ret = save_to_file (mp3file, "TCON", 4,
							  1, 0);
				      ret = sizetowrite;
				      ret = invertbits (ret);
				      //dprintf("1 valor de invertbits %d\n", ret);
				      ret = save_to_file (mp3file,
							  (char *) &ret, 4, 1,
							  0);
				      header[0] = 0;
				      header[1] = 0;
				      save_to_file (mp3file, header, 2, 1, 0);
				      save_to_file (mp3file, "\0", 1, 1, 0);
				      if (v2Genre)
					{
						save_to_file (mp3file,
							      v2Genre,
							      strlen
							      (v2Genre), 1,
							      0);
					}





			      }

			    if (TRCK)
			      {

				      ;	//dprintf("achou TRCK track \n");
				      frame_handled = 1;
				      sizetowrite = 1;
				      if (v2Track)
					{
						sizetowrite =
							sizetowrite +
							strlen (v2Track);
					}

				      ret = save_to_file (mp3file, "TRCK", 4,
							  1, 0);
				      ret = sizetowrite;
				      ret = invertbits (ret);
				      //dprintf("1 valor de invertbits %d\n", ret);
				      ret = save_to_file (mp3file,
							  (char *) &ret, 4, 1,
							  0);
				      header[0] = 0;
				      header[1] = 0;
				      save_to_file (mp3file, header, 2, 1, 0);
				      save_to_file (mp3file, "\0", 1, 1, 0);
				      if (v2Track)
					{
						save_to_file (mp3file,
							      v2Track,
							      strlen
							      (v2Track), 1,
							      0);
					}




			      }

			    if (COMM)
			      {

				      ;	//dprintf("achou COMM comments \n");
				      frame_handled = 1;
				      sizetowrite = 5;
				      if (v2Comment)
					{
						sizetowrite =
							sizetowrite +
							strlen (v2Comment);
					}

				      ret = save_to_file (mp3file, "COMM", 4,
							  1, 0);
				      ret = sizetowrite;
				      ret = invertbits (ret);
				      //dprintf("1 valor de invertbits %d\n", ret);
				      ret = save_to_file (mp3file,
							  (char *) &ret, 4, 1,
							  0);
				      header[0] = 0;
				      header[1] = 0;
				      save_to_file (mp3file, header, 2, 1, 0);
				      save_to_file (mp3file,
						    "\0\0\0\0\0\0\0\0\0\0", 5,
						    1, 0);
				      if (v2Comment)
					{
						save_to_file (mp3file,
							      v2Comment,
							      strlen
							      (v2Comment), 1,
							      0);
					}




			      }

			    if (TYER)
			      {

				      ;	//dprintf("achou TYER ano \n");
				      frame_handled = 1;
				      sizetowrite = 1;
				      if (v2Year)
					{
						sizetowrite =
							sizetowrite +
							strlen (v2Year);
					}

				      ret = save_to_file (mp3file, "TYER", 4,
							  1, 0);
				      ret = sizetowrite;
				      ret = invertbits (ret);
				      //dprintf("1 valor de invertbits %d\n", ret);
				      ret = save_to_file (mp3file,
							  (char *) &ret, 4, 1,
							  0);
				      header[0] = 0;
				      header[1] = 0;
				      save_to_file (mp3file, header, 2, 1, 0);
				      save_to_file (mp3file, "\0", 1, 1, 0);
				      if (v2Year)
					{
						save_to_file (mp3file, v2Year,
							      strlen (v2Year),
							      1, 0);
					}




			      }
			    if (TALB)
			      {
//TENC  encoded by , flag 40 00
				      ;	//dprintf("achou TALB album \n");
				      frame_handled = 1;
				      sizetowrite = 1;
				      if (v2Album)
					{
						sizetowrite =
							sizetowrite +
							strlen (v2Album);
					}

				      ret = save_to_file (mp3file, "TALB", 4,
							  1, 0);
				      ret = sizetowrite;
				      ret = invertbits (ret);
				      //dprintf("1 valor de invertbits %d\n", ret);
				      ret = save_to_file (mp3file,
							  (char *) &ret, 4, 1,
							  0);
				      header[0] = 0;
				      header[1] = 0;
				      save_to_file (mp3file, header, 2, 1, 0);
				      save_to_file (mp3file, "\0", 1, 1, 0);
				      if (v2Album)
					{
						save_to_file (mp3file,
							      v2Album,
							      strlen
							      (v2Album), 1,
							      0);
					}




			      }

			    if (TPE1)
			      {

				      ;	//dprintf("achou TPE1 artist \n");
				      frame_handled = 1;
				      sizetowrite = 1;
				      if (v2Artist)
					{
						sizetowrite =
							sizetowrite +
							strlen (v2Artist);
					}

				      ret = save_to_file (mp3file, "TPE1", 4,
							  1, 0);
				      ret = sizetowrite;
				      ret = invertbits (ret);
				      //dprintf("1 valor de invertbits %d\n", ret);
				      ret = save_to_file (mp3file,
							  (char *) &ret, 4, 1,
							  0);
				      header[0] = 0;
				      header[1] = 0;
				      save_to_file (mp3file, header, 2, 1, 0);
				      save_to_file (mp3file, "\0", 1, 1, 0);
				      if (v2Artist)
					{
						save_to_file (mp3file,
							      v2Artist,
							      strlen
							      (v2Artist), 1,
							      0);
					}




			      }

			    if (TIT2)
			      {

				      ;	//dprintf("achou TIT2 title \n");
				      frame_handled = 1;
				      sizetowrite = 1;
				      if (v2Title)
					{
						sizetowrite =
							sizetowrite +
							strlen (v2Title);
					}

				      ret = save_to_file (mp3file, "TIT2", 4,
							  1, 0);
				      ret = sizetowrite;
				      ret = invertbits (ret);
				      //dprintf("1 valor de invertbits %d\n", ret);
				      ret = save_to_file (mp3file,
							  (char *) &ret, 4, 1,
							  0);
				      header[0] = 0;
				      header[1] = 0;
				      save_to_file (mp3file, header, 2, 1, 0);
				      save_to_file (mp3file, "\0", 1, 1, 0);
				      if (v2Title)
					{
						save_to_file (mp3file,
							      v2Title,
							      strlen
							      (v2Title), 1,
							      0);
					}




			      }


/*HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH*/






			    goto finish;
		    }


		  memset (v2nome, 0, 10);
		  memcpy (v2nome, ptr, 4);;	//dprintf("deve ser o nome .%s. \n", v2nome);
		  ptr = ptr + 4;;	//dprintf("%d %d %d %d  \n", ptr[0], ptr[1], ptr[2], ptr[3]);
		  iptr = (int *) ptr;;	//dprintf("Deve ser o tamanho %x \n", *iptr);
		  framesize = invertbits (*iptr);;	//dprintf("Deve ser o tamanho %d \n", framesize);
		  //dprintf("2 valor de invertbits %d\n", framesize);

		  if ((framesize >= (thesize) || (framesize < 0)))
		    {
			    // dprintf(" erro de framesize em write %d %s\n", framesize, v2nome);
			    framesize = 1;
			    memset (v2nome, 0, 10);
			    noterror = 1;
		    }



		  ptr = ptr + 4;
		  ptr++;
		  ptr++;



		  //mprintf("framesize %d\n",framesize);



		  if (framesize > 64000)
		    {


			    returnvalue = 8;
			    goto saida;
		    }

		  theframe = malloc (framesize + 10);
		  memset (theframe, 0, framesize + 10);
		  memcpy (theframe, ptr, framesize);
		  theframe2 = malloc (framesize + 10);
		  memset (theframe2, 0, framesize + 10);
		  memcpy (theframe2, ptr, framesize);


		  if (!memcmp (v2nome, "TENC", 4))
		    {

			    if (0 == TENC)
			      {

				      goto proximo;
			      }

			    TENC = 0;
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2EncodedBy)
			      {
				      sizetowrite =
					      sizetowrite +
					      strlen (v2EncodedBy);
			      }

			    ret = save_to_file (mp3file, "TENC", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0x40;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2EncodedBy)
			      {
				      save_to_file (mp3file, v2EncodedBy,
						    strlen (v2EncodedBy), 1,
						    0);
			      }





		    }

//goto saida;


		  if (!memcmp (v2nome, "WXXX", 4))
		    {



			    if (0 == WXXX)
			      {

				      goto proximo;
			      }
			    WXXX = 0;;	//dprintf("achou WXXX url \n");
			    frame_handled = 1;
			    sizetowrite = 2;
			    if (v2URL)
			      {
				      sizetowrite =
					      sizetowrite + strlen (v2URL);
			      }

			    ret = save_to_file (mp3file, "WXXX", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0\0", 2, 1, 0);
			    if (v2URL)
			      {
				      save_to_file (mp3file, v2URL,
						    strlen (v2URL), 1, 0);
			      }




		    }


		  if (!memcmp (v2nome, "TCOP", 4))
		    {
//TENC  encoded by , flag 40 00
			    ;	//dprintf("achou TCOP copyright \n");
			    if (0 == TCOP)
			      {

				      goto proximo;
			      }
			    TCOP = 0;
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2Copyright)
			      {
				      sizetowrite =
					      sizetowrite +
					      strlen (v2Copyright);
			      }

			    ret = save_to_file (mp3file, "TCOP", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2Copyright)
			      {
				      save_to_file (mp3file, v2Copyright,
						    strlen (v2Copyright), 1,
						    0);
			      }





		    }

		  if (!memcmp (v2nome, "TOPE", 4))
		    {

			    if (0 == TOPE)
			      {

				      goto proximo;
			      }

			    TOPE = 0;;	//dprintf("achou TOPE original artist \n");
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2OriginalArtist)
			      {
				      sizetowrite =
					      sizetowrite +
					      strlen (v2OriginalArtist);
			      }

			    ret = save_to_file (mp3file, "TOPE", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2OriginalArtist)
			      {
				      save_to_file (mp3file, v2OriginalArtist,
						    strlen (v2OriginalArtist),
						    1, 0);
			      }




		    }

		  if (!memcmp (v2nome, "TCOM", 4))
		    {

			    if (0 == TCOM)
			      {

				      goto proximo;
			      }
			    TCOM = 0;;	//dprintf("achou TCOM composer \n");
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2Composer)
			      {
				      sizetowrite =
					      sizetowrite +
					      strlen (v2Composer);
			      }

			    ret = save_to_file (mp3file, "TCOM", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2Composer)
			      {
				      save_to_file (mp3file, v2Composer,
						    strlen (v2Composer), 1,
						    0);
			      }



		    }

		  if (!memcmp (v2nome, "TCON", 4))
		    {

			    if (0 == TCON)
			      {

				      goto proximo;
			      }

			    TCON = 0;;	//dprintf("achou TCON genre \n");
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2Genre)
			      {
				      sizetowrite =
					      sizetowrite + strlen (v2Genre);
			      }

			    ret = save_to_file (mp3file, "TCON", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2Genre)
			      {
				      save_to_file (mp3file, v2Genre,
						    strlen (v2Genre), 1, 0);
			      }





		    }

		  if (!memcmp (v2nome, "TRCK", 4))
		    {

			    if (0 == TRCK)
			      {

				      goto proximo;
			      }
			    TRCK = 0;;	//dprintf("achou TRCK track \n");
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2Track)
			      {
				      sizetowrite =
					      sizetowrite + strlen (v2Track);
			      }

			    ret = save_to_file (mp3file, "TRCK", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2Track)
			      {
				      save_to_file (mp3file, v2Track,
						    strlen (v2Track), 1, 0);
			      }




		    }

		  if (!memcmp (v2nome, "COMM", 4))
		    {

			    if (0 == COMM)
			      {

				      goto proximo;
			      }
			    COMM = 0;;	//dprintf("achou COMM comments \n");
			    frame_handled = 1;
			    sizetowrite = 5;
			    if (v2Comment)
			      {
				      sizetowrite =
					      sizetowrite +
					      strlen (v2Comment);
			      }

			    ret = save_to_file (mp3file, "COMM", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0\0\0\0\0\0\0\0\0\0", 5,
					  1, 0);
			    if (v2Comment)
			      {
				      save_to_file (mp3file, v2Comment,
						    strlen (v2Comment), 1, 0);
			      }




		    }

		  if (!memcmp (v2nome, "TYER", 4))
		    {

			    if (0 == TYER)
			      {

				      goto proximo;
			      }

			    TYER = 0;;	//dprintf("achou TYER ano \n");
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2Year)
			      {
				      sizetowrite =
					      sizetowrite + strlen (v2Year);
			      }

			    ret = save_to_file (mp3file, "TYER", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2Year)
			      {
				      save_to_file (mp3file, v2Year,
						    strlen (v2Year), 1, 0);
			      }




		    }
		  if (!memcmp (v2nome, "TALB", 4))
		    {
//TENC  encoded by , flag 40 00
			    ;	//dprintf("achou TALB album \n");
			    if (0 == TALB)
			      {

				      goto proximo;
			      }

			    TALB = 0;
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2Album)
			      {
				      sizetowrite =
					      sizetowrite + strlen (v2Album);
			      }

			    ret = save_to_file (mp3file, "TALB", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2Album)
			      {
				      save_to_file (mp3file, v2Album,
						    strlen (v2Album), 1, 0);
			      }




		    }

		  if (!memcmp (v2nome, "TPE1", 4))
		    {
			    if (0 == TPE1)
			      {

				      goto proximo;
			      }


			    TPE1 = 0;;	//dprintf("achou TPE1 artist \n");
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2Artist)
			      {
				      sizetowrite =
					      sizetowrite + strlen (v2Artist);
			      }

			    ret = save_to_file (mp3file, "TPE1", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2Artist)
			      {
				      save_to_file (mp3file, v2Artist,
						    strlen (v2Artist), 1, 0);
			      }




		    }

		  if (!memcmp (v2nome, "TIT2", 4))
		    {

			    ;	//dprintf("achou TIT2 title \n");
			    if (0 == TIT2)
			      {

				      goto proximo;
			      }
			    TIT2 = 0;
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2Title)
			      {
				      sizetowrite =
					      sizetowrite + strlen (v2Title);
			      }

			    ret = save_to_file (mp3file, "TIT2", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2Title)
			      {
				      save_to_file (mp3file, v2Title,
						    strlen (v2Title), 1, 0);
			      }
		    }

		  if ((0 == frame_handled) && noterror)
		    {
// aqui copia inteiro o negocio se nao pegar a informacao
			    save_to_file (mp3file, v2nome, 4, 1, 0);
			    ret = invertbits (framesize);
			    save_to_file (mp3file, (char *) &ret, 4, 1, 0);
			    save_to_file (mp3file, "\0\0", 2, 1, 0);
			    save_to_file (mp3file, theframe2, framesize, 1,
					  0);
		    }
/* ta proximo do final agra somente juntar tudo atualizar a informacao e mandar brasa no resto */

		proximo:

		  ptr += framesize;
		  free (theframe);
		  theframe = NULL;
		  free (theframe2);
		  theframe2 = NULL;
		  frame_handled = 0;
		  goto getinfo;;
	  }
	else
	  {


		  ;		//dprintf("nao tem v2 tag \n");
		  // tem que criar o treco do inicio ja
		  if (1)
		    {

			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2EncodedBy)
			      {
				      sizetowrite =
					      sizetowrite +
					      strlen (v2EncodedBy);
			      }

			    ret = save_to_file (mp3file, "TENC", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0x40;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2EncodedBy)
			      {
				      save_to_file (mp3file, v2EncodedBy,
						    strlen (v2EncodedBy), 1,
						    0);
			      }





		    }

//goto saida;


		  if (1)
		    {

			    ;	//dprintf("achou WXXX url \n");
			    frame_handled = 1;
			    sizetowrite = 2;
			    if (v2URL)
			      {
				      sizetowrite =
					      sizetowrite + strlen (v2URL);
			      }

			    ret = save_to_file (mp3file, "WXXX", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0\0", 2, 1, 0);
			    if (v2URL)
			      {
				      save_to_file (mp3file, v2URL,
						    strlen (v2URL), 1, 0);
			      }




		    }


		  if (1)
		    {
//TENC  encoded by , flag 40 00
			    ;	//dprintf("achou TCOP copyright \n");
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2Copyright)
			      {
				      sizetowrite =
					      sizetowrite +
					      strlen (v2Copyright);
			      }

			    ret = save_to_file (mp3file, "TCOP", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2Copyright)
			      {
				      save_to_file (mp3file, v2Copyright,
						    strlen (v2Copyright), 1,
						    0);
			      }





		    }

		  if (1)
		    {

			    ;	//dprintf("achou TOPE original artist \n");
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2OriginalArtist)
			      {
				      sizetowrite =
					      sizetowrite +
					      strlen (v2OriginalArtist);
			      }

			    ret = save_to_file (mp3file, "TOPE", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2OriginalArtist)
			      {
				      save_to_file (mp3file, v2OriginalArtist,
						    strlen (v2OriginalArtist),
						    1, 0);
			      }




		    }

		  if (1)
		    {

			    ;	//dprintf("achou TCOM composer \n");
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2Composer)
			      {
				      sizetowrite =
					      sizetowrite +
					      strlen (v2Composer);
			      }

			    ret = save_to_file (mp3file, "TCOM", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2Composer)
			      {
				      save_to_file (mp3file, v2Composer,
						    strlen (v2Composer), 1,
						    0);
			      }



		    }

		  if (1)
		    {

			    ;	//dprintf("achou TCON genre \n");
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2Genre)
			      {
				      sizetowrite =
					      sizetowrite + strlen (v2Genre);
			      }

			    ret = save_to_file (mp3file, "TCON", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2Genre)
			      {
				      save_to_file (mp3file, v2Genre,
						    strlen (v2Genre), 1, 0);
			      }





		    }

		  if (1)
		    {

			    ;	//dprintf("achou TRCK track \n");
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2Track)
			      {
				      sizetowrite =
					      sizetowrite + strlen (v2Track);
			      }

			    ret = save_to_file (mp3file, "TRCK", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2Track)
			      {
				      save_to_file (mp3file, v2Track,
						    strlen (v2Track), 1, 0);
			      }




		    }

		  if (1)
		    {

			    ;	//dprintf("achou COMM comments \n");
			    frame_handled = 1;
			    sizetowrite = 5;
			    if (v2Comment)
			      {
				      sizetowrite =
					      sizetowrite +
					      strlen (v2Comment);
			      }

			    ret = save_to_file (mp3file, "COMM", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0\0\0\0\0\0\0\0\0\0", 5,
					  1, 0);
			    if (v2Comment)
			      {
				      save_to_file (mp3file, v2Comment,
						    strlen (v2Comment), 1, 0);
			      }




		    }

		  if (1)
		    {

			    ;	//dprintf("achou TYER ano \n");
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2Year)
			      {
				      sizetowrite =
					      sizetowrite + strlen (v2Year);
			      }

			    ret = save_to_file (mp3file, "TYER", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2Year)
			      {
				      save_to_file (mp3file, v2Year,
						    strlen (v2Year), 1, 0);
			      }




		    }
		  if (1)
		    {
//TENC  encoded by , flag 40 00
			    ;	//dprintf("achou TALB album \n");
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2Album)
			      {
				      sizetowrite =
					      sizetowrite + strlen (v2Album);
			      }

			    ret = save_to_file (mp3file, "TALB", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2Album)
			      {
				      save_to_file (mp3file, v2Album,
						    strlen (v2Album), 1, 0);
			      }




		    }

		  if (1)
		    {

			    ;	//dprintf("achou TPE1 artist \n");
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2Artist)
			      {
				      sizetowrite =
					      sizetowrite + strlen (v2Artist);
			      }

			    ret = save_to_file (mp3file, "TPE1", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2Artist)
			      {
				      save_to_file (mp3file, v2Artist,
						    strlen (v2Artist), 1, 0);
			      }




		    }

		  if (1)
		    {

			    ;	//dprintf("achou TIT2 title \n");
			    frame_handled = 1;
			    sizetowrite = 1;
			    if (v2Title)
			      {
				      sizetowrite =
					      sizetowrite + strlen (v2Title);
			      }

			    ret = save_to_file (mp3file, "TIT2", 4, 1, 0);
			    ret = sizetowrite;
			    ret = invertbits (ret);
			    ret = save_to_file (mp3file, (char *) &ret, 4, 1,
						0);
			    header[0] = 0;
			    header[1] = 0;
			    save_to_file (mp3file, header, 2, 1, 0);
			    save_to_file (mp3file, "\0", 1, 1, 0);
			    if (v2Title)
			      {
				      save_to_file (mp3file, v2Title,
						    strlen (v2Title), 1, 0);
			      }




		    }



	  }

      finish:
// se estaaqui somente tem que terminar o item de salvamento

	{

		static char buffer[4097];
		int ret;
		int atributos;
		atributos = GetFileAttributes (filename);
		ret = SetFileAttributes (filename, FILE_ATTRIBUTE_NORMAL);
//save_to_file (mp3file, theframe2, framesize, 1, 0);
		ret = (int)getfilesize (mp3file);
// agora deve escrever a informacao dentro do arquivo
		header[0] = 'I';
		header[1] = 'D';
		header[2] = '3';
		// Version number
		header[3] = 3;
		header[4] = 0;
		// Clear Flags byte
		header[5] = 0;
		// Write tag length
		header[6] = ((ret >> 21) & 0x7F);
		header[7] = ((ret >> 14) & 0x7F);
		header[8] = ((ret >> 7) & 0x7F);
		header[9] = ((ret) & 0x7F);;	//dprintf("valor do tag %d \n", ret);
//save_to_file (mp3file, header, 10, 1, 0);
		if ((out = _wfopen (utf8towide(mp3file), L"rb+")) == NULL)
		  {
			  //dprintf          ("The file 'data' was not opened\n");
			  returnvalue = 4;	//cannot open temp file to write
			  goto saida;
		  }
		else
		  {
			  //dprintf          ("The file 'data' was opened\n");
		  }

		ret = fwrite_unbuffered (header, 1, 10, out);
		fclose (out);
		out = NULL;
		save_to_file (mp3file, "\0\0\0\0\0\0\0\0\0\0\0", 10, 1, 0);
// aqui agora somente copia um em cima de outro e fim de papo
		if ((in = _wfopen (utf8towide(filename), L"rb")) == NULL)
		  {
			  //dprintf          ("The file 'data' was not opened\n");
			  returnvalue = 5;	//cannot open input file to read
			  goto saida;
		  }
		else
		  {
			  //dprintf          ("The file 'data' was opened\n");
		  }

		if ((out = _wfopen (utf8towide(mp3file), L"ab")) == NULL)
		  {
			  //dprintf          ("The file 'data' was not opened\n");
			  returnvalue = 6;	//cannot open temp file to write
			  goto saida;
		  }
		else
		  {
			  //dprintf          ("The file 'data' was opened\n");
		  }


		if (tamanhodetag)
		  {

			  ret = _fseeki64_arab (in, tamanhodetag, SEEK_SET);;	//dprintf("tamanho desocado %d \n", ftell (in));
		  }
		else
		  {

			  ;	//dprintf("nao vai deslocarporque nao tem tag \n");
		  }

	      maisum:
		ret = fread_unbuffered (buffer, 1, 4096, in);
		if (ret <= 0)
		  {

			  goto terminou;
		  }

		ret = fwrite_unbuffered (buffer, 1, ret, out);
		goto maisum;;
	      terminou:
		;
		fclose (in);
		fclose (out);
		in = NULL;
		out = NULL;;	//dprintf("fechou tudo \n");
// agora so falta copia um em cima do outro
		ret = CopyFile (mp3file, filename, 0);
		if (0 == ret)
		  {

			  returnvalue = 7;	//cannot replace original file
			  goto saida;
		  }

		if (atributos != 0xFFFFFFFF)
		  {
			  ret = SetFileAttributes (filename, atributos);
		  }

		ret = DeleteFile (mp3file);
	}



      saida:


	if (itens)
	  {
		  ;		//dprintf("liberando itens \n");
		  free (itens);
	  }

	if (theframe)
	  {

		  ;		//dprintf("nao pode ocorrer \n");
		  free (theframe);
	  }

	if (theframe2)
	  {

		  ;		//dprintf("nao pode ocorrer \n");
		  free (theframe2);
	  }

	if (in)
	  {
		  ;		//dprintf("fechando in de rebote \n");
		  fclose (in);
	  }
	if (out)
	  {
		  ;		//dprintf("fechando out de rebote \n");
		  fclose (out);
	  }


	if (didfilename)
	  {

		  if (ispathfile (mp3file))
		    {
			    ;	//dprintf("deletando arquivo temporario \n");
			    ret = DeleteFile (mp3file);
		    }

	  }

	if (returnvalue)
	  {

		  ;		//dprintf("deu erro %d \n", returnvalue);
	  }
	return returnvalue;
}


int
remove_id3v2_tag (char *filename)
{
	FILE *in = NULL;
	FILE *out = NULL;
	int sizetowrite = 0;
	int didfilename = 0;
	int tamanhodetag = 0;
	int ret;
	int returnvalue = 0;
	char *itens = NULL;
	char *theframe = NULL;
	char *theframe2 = NULL;
	char mp3file[300];
	memset (mp3file, 0, 300);
	if (detect_readonly_file (filename))
	  {

		  returnvalue = 1;	//read only
		  goto saida;
	  }

	//baduser (1);

	ret = createtempfilename (tempfolder, mp3file);
	if (!ret)
	  {
		  didfilename = 1;;	//dprintf("conseguiu criar arquivo .%s. \n", mp3file);
	  }
	else
	  {

		  ;		//dprintf("nao criou arquivo \n");
		  returnvalue = 2;	//unable to create temp file
		  goto saida;
	  }

	ret = id3v2tag_check (filename);
	if (ret)
	  {
		  static char buffer[4097];
		  int atributos;
		  tamanhodetag = ret;
		  atributos = GetFileAttributes (filename);
		  ret = SetFileAttributes (filename, FILE_ATTRIBUTE_NORMAL);
		  if ((in = _wfopen (utf8towide(filename), L"rb")) == NULL)
		    {
			    //dprintf          ("The file 'data' was not opened\n");
			    returnvalue = 3;	//cannot open input file to read
			    goto saida;
		    }
		  else
		    {
			    //dprintf          ("The file 'data' was opened\n");
		    }

		  if ((out = _wfopen (utf8towide(mp3file), L"ab")) == NULL)
		    {
			    //dprintf          ("The file 'data' was not opened\n");
			    returnvalue = 4;	//cannot open temp file to write
			    goto saida;
		    }
		  else
		    {
			    //dprintf          ("The file 'data' was opened\n");
		    }


		  if (tamanhodetag)
		    {

			    ret = _fseeki64_arab (in, tamanhodetag, SEEK_SET);;	//dprintf("tamanho desocado %d \n", ftell (in));
		    }
		  else
		    {

			    ;	//dprintf("nao vai deslocarporque nao tem tag \n");
		    }

		maisum:
		  ret = fread_unbuffered (buffer, 1, 4096, in);
		  if (ret <= 0)
		    {

			    goto terminou;
		    }

		  ret = fwrite_unbuffered (buffer, 1, ret, out);
		  goto maisum;;
		terminou:
		  ;
		  fclose (in);
		  fclose (out);
		  in = NULL;
		  out = NULL;;	//dprintf("fechou tudo \n");
// agora so falta copia um em cima do outro
		  ret = CopyFile (mp3file, filename, 0);
		  if (0 == ret)
		    {

			    returnvalue = 5;	//cannot replace original file
			    goto saida;
		    }

		  if (atributos != 0xFFFFFFFF)
		    {
			    ret = SetFileAttributes (filename, atributos);
		    }

		  ret = DeleteFile (mp3file);
	  }


      saida:


	if (itens)
	  {
		  ;		//dprintf("liberando itens \n");
		  free (itens);
	  }

	if (theframe)
	  {

		  ;		//dprintf("nao pode ocorrer \n");
		  free (theframe);
	  }

	if (theframe2)
	  {

		  ;		//dprintf("nao pode ocorrer \n");
		  free (theframe2);
	  }

	if (in)
	  {
		  ;		//dprintf("fechando in de rebote \n");
		  fclose (in);
	  }
	if (out)
	  {
		  ;		//dprintf("fechando out de rebote \n");
		  fclose (out);
	  }


	if (didfilename)
	  {

		  if (ispathfile (mp3file))
		    {
			    ;	//dprintf("deletando arquivo temporario \n");
			    ret = DeleteFile (mp3file);
		    }

	  }


	return returnvalue;
}





int
v2cleanup ()
{
	//dprintf("chamando clean up \n");

	disassemble (1);

	;			//dprintf("v2 cleaning up \n");
	v2Composersize = 0;
	v2OriginalArtistsize = 0;
	v2Copyrightsize = 0;
	v2URLsize = 0;
	v2EncodedBysize = 0;
	v2Commentsize = 0;
	v2Genresize = 0;
	v2Yearsize = 0;
	v2Albumsize = 0;
	v2Artistsize = 0;
	v2Titlesize = 0;
	v2Tracksize = 0;
	if (v2Track)
	  {

		  free (v2Track);
		  v2Track = NULL;
	  }

	if (v2Title)
	  {

		  free (v2Title);
		  v2Title = NULL;
	  }

	if (v2Artist)
	  {

		  free (v2Artist);
		  v2Artist = NULL;
	  }

	if (v2Album)
	  {

		  free (v2Album);
		  v2Album = NULL;
	  }

	if (v2Year)
	  {

		  free (v2Year);
		  v2Year = NULL;
	  }

	if (v2Genre)
	  {

		  free (v2Genre);
		  v2Genre = NULL;
	  }

	if (v2Comment)
	  {

		  free (v2Comment);
		  v2Comment = NULL;
	  }

	if (v2EncodedBy)
	  {

		  free (v2EncodedBy);
		  v2EncodedBy = NULL;
	  }

	if (v2URL)
	  {

		  free (v2URL);
		  v2URL = NULL;
	  }

	if (v2Copyright)
	  {

		  free (v2Copyright);
		  v2Copyright = NULL;
	  }

	if (v2OriginalArtist)
	  {

		  free (v2OriginalArtist);
		  v2OriginalArtist = NULL;
	  }


	if (v2Composer)
	  {

		  free (v2Composer);
		  v2Composer = NULL;
	  }

	if (naloc)
	  {
		  assert (0 && "nalloc");

	  }

	return 0;
}

/*codigo fechado , nao se modifica mais mesmo*/

#ifdef _debug_v2_ok_

#define dprintf printf
#pragma comment (lib,"user32.lib")
int
main ()
{

	//dprintf(" hi \n");
//   __asm
//   {
//
//      int 3;
//   }


	strcpy (tempfolder, "c:\\back\\");
	id3v2tag_ok ("cortada-.mp3");

	v2cleanup ();

	return 0;
}

#endif
