/*

Mon Apr 25 GMT 16:58:32 2011 , by arab

*/
/*

Small simple incomplete sample developed by Alessandra
ale@rspsoftware.com.br

If you have any doubts take a look in the MP3 OCX , since it has a fully functional sample and the name 
and utilization of the functions are almost the same

Link for the ocx: http://rspsoftware.com.br/~Alessandra_MBROczkoski_Pereira/rspmp3play.htm
Alternate       : http://maquisistem.tripod.com/~Maquisistem/rspmp3play.htm

This sample will be finished as soon I got time....

If you have time and want to contribute , just finish the documentation of:
mp3class.cs

The DLL is fully functional and can be used in shareware or comercial
software without modifications , since now the method of registration
is by user name and unlock code (function Enter_License)

As usual , free upgrades to two years (and can be extended by request)

We will always deliver new releases for any user that have 
purchased this control/OCX/dll since 1996 , just ask....

*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace mp3dll
{
    /// <summary>
    /// Form1
    /// </summary>
    public partial class sample : Form
    {

        int number = MP3.playerselection;//player selection

        private int previnstance()
        {
            // int ret;
            System.Diagnostics.Process[] ret = System.Diagnostics.Process.GetProcessesByName(System.Diagnostics.Process.GetCurrentProcess().ProcessName);

            string thestring = ret.Length.ToString();

            if (ret.Length > 1)
            {
                return 1;
            }

            return 0;

        }
        public sample()
        {
            InitializeComponent();
        }

        StringBuilder _data_ = new StringBuilder(300);


        int is_seeking = 0;
        private void timer1_Tick(object sender, EventArgs e)
        {

            timer1.Interval = 100;

            StringBuilder time = new StringBuilder(300);

            int ret2 = MP3.IntReturn(number);

            //////////////////section to update the playback status

            if (1000 == ret2)
            {
                if (1 == open_flag)
                {
                    label4.Text = "Status: stop";
                }
                else
                {
                    label4.Text = "Status: play";
                }
            }

            if (1001 == ret2)
            {
                label4.Text = "Status: paused";
            }

            if (ret2 < 1000)
            {
                label4.Text = "Status: stop";
            }
            ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

            label5.Text = "Sample rate: " + MP3.SampleRate(number).ToString();
            label8.Text = "Channels: " + MP3.Channels(number).ToString();

            if (1 == MP3.GetVBR(number))
            {
                label11.Text = "Is VBR: sim";
            }
            else
            {
                label11.Text = "Is VBR: no";
            }

            label7.Text = "Bitrate: " + MP3.GetBitrate(number).ToString();

            MP3.GetMpegMode(number, time);
            label6.Text = "Mode: " + time.ToString();

            if (1 == MP3.IsUsingNormalization(number))
            {
                label9.Text = "Normalization: true";
            }
            else
            {
                label9.Text = "Normalization: false";
            }

            label1.Text = "Position: " + MP3.GetTimeMilliseconds(number).ToString();

            label15.Text = "Milliseconds: " + MP3.GetLengthMilliseconds(number).ToString();

            MP3.GetMpegVersion(number, time);
            label16.Text = "MPEG Version: " + time.ToString();

            MP3.GetMpegLayer(number, time);
            label13.Text = "Layer: " + time.ToString();

            MP3.NormalizationFactor(number, time);
            label17.Text = "Normalize factor: " + time.ToString();

            left.Value = MP3.GetLeftChannel(number);
            right.Value = MP3.GetRightChannel(number);
            if(0==is_seeking)
            slider.Value = MP3.PlayBackPosition(number);

            MP3.GetTimeString(number, time);

            label14.Text = "Time position " + time.ToString();

            MP3.GetLengthString(number, time);

            label12.Text = "Time " + time.ToString();

            MP3.Alladin_GetRemainingTime(number, _data_);
            label24.Text = "Remaining time: " + _data_.ToString();

            int ret;

            ret = MP3.IntReturn(number);

            if (999 > ret)
            {
                label10.Text = "Finished event raised";
                timer1.Enabled = false;
                if (0 != ret)
                {
                    errorinfo.Items.Add("Error " + ret.ToString()+ ", check the function IntReturn to see what this error means");
                    errorinfo.SelectedIndex = errorinfo.Items.Count - 1;
                }
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {


            of1.Filter = "All supported files (*.mpg *.mp1 *.mp2 *.mp3 *.wav)|*.mpg;*.mp1;*.mp2;*.mp3;*.wav|All files (*.*)|*.*";
            of1.FileName = "";
            DialogResult dlg = of1.ShowDialog();

            if (dlg == DialogResult.OK)
            {
                filename.Text = of1.FileName;
            }
        }

        int disable = 0;
        StringBuilder settings = new StringBuilder(300);
        private void Form1_Load(object sender, EventArgs e)
        {
            
            int ret;

            settings = new StringBuilder(300);
            MP3.GetSettings(number, "usevbr", settings, "0");

            if ("1" == settings.ToString())
            {
                vbr.CheckState = CheckState.Checked;
            }
            else
            {
                vbr.CheckState = CheckState.Unchecked;
            }

            MP3.GetSettings(number, "volume", settings, "10");
            slider3.Value = int.Parse(settings.ToString());

            slider3_Scroll(null, null);

            settings = new StringBuilder(300);
            MP3.GetSettings(number, "encryption", settings, "0");

            if ("1" == settings.ToString())
            {
                encryption.CheckState = CheckState.Checked;
            }
            else
            {
                encryption.CheckState = CheckState.Unchecked;
            }

            settings = new StringBuilder(300);
            MP3.GetSettings(number, "limit", settings, "250000");

            limit.Text = settings.ToString();
            MP3.PlayFromMemoryFileSizeLimit(number, int.Parse(settings.ToString()));
            
            settings = new StringBuilder(300);
            MP3.GetSettings(number, "smart", settings, "1");

            if ("1" == settings.ToString())
            {
                nobuffer.CheckState = CheckState.Unchecked;
                smart.CheckState = CheckState.Checked;
            }
            else
            {
                nobuffer.CheckState = CheckState.Checked;
                smart.CheckState = CheckState.Unchecked;
            }

            StringBuilder euo = new StringBuilder(300);

            MP3.ControlName(euo);
            this.Text = euo.ToString() + " - Sample Project";
            
            settings = new StringBuilder(300);
            MP3.GetSettings(number, "filename", settings, "");
            filename.Text = MP3.utf82wide( settings.ToString());
            
            settings = new StringBuilder(300);
            MP3.GetSettings(number, "loop", settings, "0");

            if ("0" == settings.ToString())
            {
                loop.CheckState = CheckState.Unchecked;
            }
            else
            {
                loop.CheckState = CheckState.Checked;
            }


            priority.Items.Add("IDLE");
            priority.Items.Add("NORMAL");
            priority.Items.Add("HIGH");

            settings = new StringBuilder(300);
            MP3.GetSettings(number, "priority", settings, "1");

            priority.SelectedIndex = int.Parse(settings.ToString());

            ret = MP3.GetNumberofWaveOutDevices(number);

            if (0 == ret)
            {
                MessageBox.Show("No soundcard installed in the system ");
                waveout.Text = "<no soundcard>";
            }
            else
            {
                disable = 1;

                int l;

                for (l = 0; l < ret; l++)
                {
                    settings = new StringBuilder(300);
                    MP3.GetWaveOutDevicesName(number, l, settings);
                    waveout.Items.Add(settings.ToString());
                }
                settings = new StringBuilder(300);
                MP3.GetSettings(number, "waveout", settings, "0");
                waveout.SelectedIndex = int.Parse(settings.ToString());

                disable = 0;
            }

        }

        private void nobuffer_MouseUp(object sender, MouseEventArgs e)
        {

            if (CheckState.Checked == nobuffer.CheckState)
            {
                MP3.SaveSettings(number, "smart", "0");
                MP3.UseOldFileBufferMode(1);

                smart.CheckState = CheckState.Unchecked;
            }
            else
            {
                MP3.SaveSettings(number, "smart", "1");
                MP3.UseSmartFileBufferMode(1);
                smart.CheckState = CheckState.Checked;
            }
        }

        private void smart_MouseUp(object sender, MouseEventArgs e)
        {
            if (CheckState.Checked == smart.CheckState)
            {
                MP3.SaveSettings(number, "smart", "1");
                MP3.UseSmartFileBufferMode(number);
                nobuffer.CheckState = CheckState.Unchecked;

            }
            else
            {
                MP3.SaveSettings(number, "smart", "0");
                MP3.UseOldFileBufferMode(number);
                nobuffer.CheckState = CheckState.Checked;
            }
        }

        private void limit_TextChanged(object sender, EventArgs e)
        {
            int ret = 0;

            if ("" == limit.Text)
            {
                return;
            }

            try
            {
                ret = int.Parse(limit.Text);
            }
            catch
            {
                limit.Text = "200000";
                return;
            }
            if (ret > 20000000)
            {
                MessageBox.Show("File load size limit is 20 megabytes , it will avoid the system stop responding if the user pass a value larger than this , since the memory required will be too large and can make the system unstable , for a 20 megabytes file , a 20 megabytes buffer will be allocated in the memory ");
                limit.Text = "20000000";
                return;
            }

            MP3.PlayFromMemoryFileSizeLimit(number, ret);

            MP3.SaveSettings(number, "limit", ret.ToString());

        }

        private void waveout_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (disable > 0)
            {
                return;
            }

            MP3.SaveSettings(number, "waveout", waveout.SelectedIndex.ToString());
            
        }

        private void loop_MouseUp(object sender, MouseEventArgs e)
        {

            if (CheckState.Checked == loop.CheckState)
            {
                MP3.SaveSettings(number, "loop", "1");
            }
            else
            {
                MP3.SaveSettings(number, "loop", "0");
            }

        }

        private void button4_Click(object sender, EventArgs e)
        {
            open_flag = 0;
            label10.Text = "Playing";

            //  MP3.RegisterFinishedEventMessage(number, 0, 0);


            if (CheckState.Checked == encryption.CheckState)
            {
                MP3.UseEncryption(number, 1, pass.Text);
            }
            else
            {
                MP3.UseEncryption(number, 0, pass.Text);
            }

            if (CheckState.Checked == vbr.CheckState)
            {
                MP3.DisableVBR(number, 1);
            }
            else
            {
                MP3.DisableVBR(number, 0);
            }

            MP3.SetWaveOutDevice(number, waveout.SelectedIndex);

            if (CheckState.Checked == loop.CheckState)
            {
                MP3.PlayMp3(number,MP3.wide2utf8( filename.Text), 1);
            }
            else
            {
                MP3.PlayMp3(number,MP3.wide2utf8( filename.Text), 0);
            }

            timer1.Enabled = true;

        }

        private void encryption_MouseUp(object sender, MouseEventArgs e)
        {

            if (CheckState.Checked == encryption.CheckState)
            {
                MP3.SaveSettings(number, "encryption", "1");
            }
            else
            {
                MP3.SaveSettings(number, "encryption", "0");
            }

        }

        private void vbr_MouseUp(object sender, MouseEventArgs e)
        {

            if (CheckState.Checked == vbr.CheckState)
            {
                MP3.SaveSettings(number, "usevbr", "1");
            }
            else
            {
                MP3.SaveSettings(number, "usevbr", "0");
            }

        }

        private void filename_TextChanged(object sender, EventArgs e)
        {
            MP3.SaveSettings(number, "filename",MP3.wide2utf8 ( filename.Text));
        }

        int open_flag = 0;
        private void button6_Click(object sender, EventArgs e)
        {
            open_flag = 1;

            label10.Text = "Playing";

            // MP3.RegisterFinishedEventMessage(number, 0, 0);


            if (CheckState.Checked == encryption.CheckState)
            {
                MP3.UseEncryption(number, 1, pass.Text);
            }
            else
            {
                MP3.UseEncryption(number, 0, pass.Text);
            }

            if (CheckState.Checked == vbr.CheckState)
            {
                MP3.DisableVBR(number, 1);
            }
            else
            {
                MP3.DisableVBR(number, 0);
            }

            MP3.SetWaveOutDevice(number, waveout.SelectedIndex);

            if (CheckState.Checked == loop.CheckState)
            {
                MP3.OpenMp3(number,MP3.wide2utf8( filename.Text), 1);
            }
            else
            {
                MP3.OpenMp3(number,MP3.wide2utf8( filename.Text), 0);
            }

            timer1.Enabled = true;


        }

        private void button7_Click(object sender, EventArgs e)
        {
            MP3.PlaybackPause(number);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            MP3.PlaybackResume(number);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            MP3.PlaybackCancel(number);
            label4.Text = "Status: stop";
            label10.Text = "Cancel";
        }

        private void slider2_Scroll(object sender, EventArgs e)
        {
            MP3.SetVolumeGain(number, slider2.Value * 10);
        }

        private void slider3_Scroll(object sender, EventArgs e)
        {
            MP3.InternalVolume(number, slider3.Value * 10);

            MP3.SaveSettings(number, "volume", slider3.Value.ToString());
        }

        private void slider_KeyUp(object sender, KeyEventArgs e)
        {
            timer1.Interval = 2000;

            if (seekseconds.CheckState == CheckState.Unchecked)
            {
                MP3.SeekTo(number, slider.Value);
            }
            else
            {
                MP3.SeekBasedOnSeconds(number, slider.Value);
            }
        }

        private void priority_SelectedIndexChanged(object sender, EventArgs e)
        {
            if ("IDLE" == priority.Text)
            {
                MP3.SetPriority(number, 0);
            }
            if ("NORMAL" == priority.Text)
            {
                MP3.SetPriority(number, 1);
            }
            if ("HIGH" == priority.Text)
            {
                MP3.SetPriority(number, 2);
            }

        }

        private void button9_Click(object sender, EventArgs e)
        {
            //to do
        }

        private void button10_Click(object sender, EventArgs e)
        {
            /* why the rest of the code is not so easy to write like this...*/
            label10.Text = "Converting...";
            this.Refresh();
            int ret;
            ret = MP3.ConvertMP3ToWav(number,MP3.wide2utf8( filename.Text),MP3.wide2utf8( filetowav.Text));
            label10.Text = "Finished...";

        }
        /*
        private void checkBox1_MouseUp(object sender, MouseEventArgs e)
        {

            if (madlib.CheckState == CheckState.Checked)
            {
                //default to Madlib
                MP3.SelectMP3Decoder(number, 1);
            }
            else
            {
                MP3.SelectMP3Decoder(number, 0);
            }

        }*/
        int position_new = 0;
        private void slider_Scroll(object sender, EventArgs e)
        {

            position_new = slider.Value;
            /*
            timer1.Interval = 2000;

            if (seekseconds.CheckState == CheckState.Unchecked)
            {
                MP3.SeekTo(number, slider.Value);
            }
            else
            {
                MP3.SeekBasedOnSeconds(number, slider.Value);
            }
             * */
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MP3.About();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            equalizer eu = new equalizer();

            eu.Show();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            normalize eu = new normalize();

            eu.Show();
        }

        private void button11_Click(object sender, EventArgs e)
        {
            spectrum eu = new spectrum();

            eu.Show();
        }

        private void button12_Click(object sender, EventArgs e)
        {
#if !NPRINTF

            MP3.dprintf("***************");
#endif
            int i;

            for (i = 0; i < 150; i++)
            {
                StringBuilder data_ = new StringBuilder(300);

                MP3.Generate_ID3v1Genre(number, i, data_);
#if !NPRINTF

                MP3.dprintf(data_.ToString());
#endif

            }


        }

        private void button12_Click_1(object sender, EventArgs e)
        {
            DebugInformation eu = new DebugInformation();

            eu.Show();
        }

        private void button13_Click(object sender, EventArgs e)
        {
            //ok
            wave_effects eu = new wave_effects();

            eu.Show();
        }

        private void slider_MouseUp(object sender, MouseEventArgs e)
        {
            liberador.Enabled = true;
            if (seekseconds.CheckState == CheckState.Unchecked)
            {
                MP3.SeekTo(number, position_new );
            }
            else
            {
                MP3.SeekBasedOnSeconds(number, position_new);
            }
        }

        private void slider_MouseDown(object sender, MouseEventArgs e)
        {
            is_seeking = 1;
        }

        private void liberador_Tick(object sender, EventArgs e)
        {
            liberador.Enabled = false;
            is_seeking = 0;
        }
    }
}
